package rocks.zipcode.quiz5.fundamentals;

import java.util.HashSet;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.toCharArray()[middle(string.length())];
    }

    public static String capitalizeMiddleCharacter(String str) {
        char[] temp = str.toCharArray();
        temp[middle(str.length())] = Character.toUpperCase(temp[middle(str.length())]);

        return new String(temp);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        char[] temp = str.toCharArray();
        temp[middle(str.length())] = Character.toLowerCase(temp[middle(str.length())]);

        return new String(temp);
    }

    public static Boolean isIsogram(String str) {
        HashSet<Character> filter = new HashSet<>();
        char[] temp = str.toCharArray();
        int counter = 0;
        for (char c: temp) {filter.add(c); counter ++;}

        return (filter.size() == temp.length);
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        char[] temp = str.toCharArray();
        char tempChar = temp[0];
        boolean result = false;

        for (int i = 1; i < temp.length; i++) {
            if (tempChar != temp[i]) {
                tempChar = temp[i];
            } else {
                result = true;
            }
        }
        return result;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {

        StringBuilder builder = new StringBuilder();

        if (hasDuplicateConsecutiveCharacters(str)) {
            char[] temp = str.toCharArray();
            char tempChar = temp[0];

            for (int i = 1; i < temp.length; i++) {
                if (tempChar == temp[i]) {
                    tempChar = temp[i+1];
                    i++;
                } else {
                    builder.append(tempChar);
                    tempChar = temp[i+1];
                }
            }
        }
        return builder.toString();
    }

    public static String invertCasing(String str) {
        StringBuilder builder = new StringBuilder();
        char[] temp = str.toCharArray();

        for (char c: temp) {
            if (Character.isUpperCase(c)){
                c = Character.toLowerCase(c);
                builder.append(c);
            } else {
                c = Character.toUpperCase(c);
                builder.append(c);
            }
        }
        return builder.toString();
    }

    public static int middle (int value){
        return (value - 1) / 2;
    }
}