package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable {

    public Double balance;

    public void setBalance(Double val) {
        balance=val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if (amountToIncreaseBy < 0) {
            throw new IllegalArgumentException("Cannot increase by a negative dollar amount.");
        } else {
            balance += amountToIncreaseBy;
        }
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        if (amountToDecreaseBy > balance || amountToDecreaseBy < 0){
            throw new IllegalArgumentException (amountToDecreaseBy + " exceeds withdrawable amount.");
        } else {
            balance = balance - amountToDecreaseBy;
        }
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}