package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee implements Worker, Transactable {

    private Double hours;

    private final Double hourlyWage = 35.0;

    private BankAccount account;

    public Employee() {
        account = new BankAccount();
        account.setBalance(0.0);
        hours = 0.0;
    }

    public Employee(BankAccount bankAccount) {
        account = bankAccount;
        hours = 0.0;
    }

    public BankAccount getBankAccount() {
        return account;
    }

    public void setBankAccount(BankAccount bankAccount) {
        account = bankAccount;
    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        hours += numberOfHours;
    }

    @Override
    public Double getHoursWorked() {
        return hours;
    }

    @Override
    public Double getHourlyWage() {
        return hourlyWage;
    }

    @Override
    public Double getMoneyEarned() {
        return hours * hourlyWage;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        account.deposit(amountToIncreaseBy);
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        account.withdrawal(amountToDecreaseBy);
    }

    @Override
    public Double getBalance() {
        return account.getBalance();
    }
}
